/*
   take care of printing debugging output

   $dodge: debug.c,v 1.7 2005/01/24 04:07:21 dodge Exp $
   $Name: version_3 $
 */

#include "tl.h"

FILE *debugfd;

void debuginit ()
{
	int	mypid;

	mypid = getpid();

	if (debug_filename != NULL)
	{
		if (strcmp(debug_filename, "-") == 0)
		{
			debugfd = stderr;
		} else {
			if ((debugfd = fopen(debug_filename, "w")) == NULL ) {
				fprintf(stderr, "Can't open %s: %s",
				debug_filename, strerror(errno));
			}
		}
		setvbuf(debugfd, NULL, _IONBF, 0);
	}

	return;
}

void debugout (char *file, int line, char *fmt, ...)
{
	va_list	 ap;
	struct timeval tv;
	char  *c;

	if (debugfd == NULL)
	{
		return;
	}
	
	gettimeofday(&tv, NULL);
	c = (char *)ctime((const time_t *)&(tv.tv_sec));
	c[strlen(c) -1] = 0;
	fprintf(debugfd, "%s %s:%d: ", c, file, line);
	va_start(ap, fmt);
	vfprintf(debugfd, fmt, ap);
	va_end(ap);
	fflush(debugfd);
	return;
}
